/**
 * Par Alain VIZZINI
 * Cration              : 16 mars 2002
 * Dernire modification : 16 mars 2002
 */

using System;
using System.Collections;
using K = System.Console;

[Serializable]
public class ConsultationPediatrie : RendezVous {
    private static SortedList consultationSet;
    private static readonly int duree= 20;
    
    public override int Duree() { return duree; }


    //Un constructeur DE CLASSE en une ligne. Merci C# !
    static ConsultationPediatrie(){
      consultationSet = new SortedList(new RDVComparateur());
    }

    private ConsultationPediatrie() : base (){}

    private ConsultationPediatrie(int an, int mois, int jour, int heure, int min, String s) : base (an,  mois,  jour,  heure,  min, s){}

    public override String ToString(){
	return "PEDIATRIE: " + ihmToString();
    }
    public String ihmToString(){
	return base.ToString() + ". Duree : " + Duree() + " minutes.";
    }

    public static String PrendreRendezVous(int an, int mois, int jour, int heure, int min, String s) {       
	ConsultationPediatrie r = new ConsultationPediatrie(an, mois, jour, heure, min, s);
	if (PrendreRendezVous(r,consultationSet))
	    return "Rendez vous enregistr --> " + r;
	else
	    return "Rendez vous IMPOSSIBLE creneau horaire deja pris pour " + r;
    }

    public static String AnnulerRendezVous(String s) {       
	return AnnulerRendezVous(s,consultationSet);
    }
    public static String AnnulerRendezVous(int an, int mois, int jour, int heure, int min, String s) {       
	ConsultationPediatrie r = new ConsultationPediatrie(an, mois, jour, heure, min, s);
	return AnnulerRendezVous(r,consultationSet);
    }


    /**
     * Charge les rdv sur le disque. ATTENTION : on REMPLACE le set
     * @return true ssi cela s'est bien pass ...
     */
    public static bool Charger(){
	//on REMPLACE le set
	
	return LireFichier ("ConsultationPediatrie.db", ref consultationSet);
    }


    /**
     * Sauve les rdv sur le disque.
     * @return true ssi cela s'est bien pass ...
     */
    public static bool Sauver(){
      return SauvegarderFichier ("ConsultationPediatrie.db", consultationSet);
    }


    /**
     * Liste sur la sortie STD les RDV Pediatrie.
     */
    public static void Lister () {
	Console.WriteLine("** Les rendez vous Pediatrie");
	Lister(consultationSet);
    }


    /**
     * Liste dans un IEnumerable les rdv
     */
    public static IEnumerable IhmLister (){
	return IhmLister (consultationSet);
    }

    public static IEnumerable RechercherRendezVous(String s){
	return RechercherRendezVous(s, consultationSet);

    }

}
