using System.Collections;
using System;

//*DOIT* etre srializable car quand on serialize le Set, on srialize aussi le Comparateur
[Serializable]
public class RDVComparateur : IComparer {

  public int Compare (Object x, Object y) {
    if (!(x is DateTime) || !(y is DateTime))
      throw new ArgumentException();

    //ATTENTION : en C# DateTime est une structure !!!
    //Donc quand pass en param en tant qu'Object, on n'utilise pas le systme up/downcast 
    //mais le systme Box/Unbox. C'est pourquoi les deux lignes ci-dessus n'utilisent pas
    //la notation *as* mais une cast *()*  !!!!
    DateTime rdv1 = (DateTime)x;
    DateTime rdv2 = (DateTime)y;
    
    return DateTime.Compare (rdv1, rdv2);
  }
}
